#include <bits/stdc++.h>
using namespace std;


vector<int> used;
int s;

void dfs(int v, vector<vector<int>>& g, int p, vector<pair<int, int>>& cycle) {
    used[v] = 1;
    s++;
    cycle.push_back(make_pair(v, p));
    for (int u : g[v]) {
        if (!used[u]) {
            dfs(u, g, 1 - p, cycle);
        }
    }
}


int main() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        g[a - 1].push_back(i);
    }
    used.assign(n, 0);
    vector <pair<int, int>> cycle;
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            s = 0;
            dfs(i, g, 0, cycle);
            if (s % 2 == 1) {
                ans++;
                cycle[cycle.size() - 1].second = -1;
            }
        }
    }
    cout << ans << endl;
    for (int i = 0; i < cycle.size(); i++) {
        if (cycle[i].second == 0) {
            cout << cycle[i].first + 1 << " ";
        }
    }
    cout << endl;
    for (int i = 0; i < cycle.size(); i++) {
        if (cycle[i].second == 1) {
            cout << cycle[i].first + 1 << " ";
        }
    }
}